unit pFFmpeg;

interface

uses
  Classes,Windows;

type
  TFFmpgErrEvent = procedure(Sender: TObject; ErrorCode: Integer) of object;

  TFFmpeg = class(TThread)
  private
    { Private 錾 }
    FCommandLine        : String;
    FStdIn              : TMemoryStream;
    FStdOut             : TMemoryStream;
    FStdInReading       : Int64;
    FStdOutReading      : Int64;
    FOnWriteStdOut      : TNotifyEvent;
    FOnErrorSignal      : TFFmpgErrEvent;
    FPriority           : Cardinal;
    bufStdOut,bufErrOut : array[0..8192] of Byte;
    dwStdOut ,dwErrOut  : DWord;
    ErrCode             : Integer;
    FWatchDogTimeOut    : DWord;
    WatchDog            : DWord;
    procedure WriteStdOut;
    procedure WriteErrOut;
    procedure ErrorSignal;
  published
    property StdIn         :TMemoryStream  read FStdIn         write FStdIn         default nil;
    property StdInReading  :Int64          read FStdInReading  write FStdInReading  default 0;
    property StdOut        :TMemoryStream  read FStdOut        write FStdOut        default nil;
    property StdOutReading :Int64          read FStdOutReading write FStdOutReading default 0;
    property OnWriteStdOut :TNotifyEvent   read FOnWriteStdOut write FOnWriteStdOut default nil;
    property OnErrorSignal :TFFmpgErrEvent read FOnErrorSignal write FOnErrorSignal default nil;
    property CommandLine   :String         read FCommandLine   write FCommandLine;
    property Priority      :Cardinal       read FPriority      write FPriority      default IDLE_PRIORITY_CLASS;
    property WatchDogTimeOut:DWord         read FWatchDogTimeOut write FWatchDogTimeOut default (20*1000);
  protected
    procedure Execute; override;
  end;

implementation

{ TFFmpeg }

procedure TFFmpeg.WriteStdOut;
begin
  StdOut.Write(bufStdOut, dwStdOut);
  if (@FOnWriteStdOut<>nil) then FOnWriteStdOut(self);
end;

procedure TFFmpeg.WriteErrOut;
begin
  StdOut.Write(bufErrOut, dwErrOut);
  if (@FOnWriteStdOut<>nil) then FOnWriteStdOut(self);
end;

procedure TFFmpeg.ErrorSignal;
begin
  if (@FOnErrorSignal<>nil) then FOnErrorSignal(self,ErrCode);
end;

procedure TFFmpeg.Execute;
var
  hReadPipe, hWritePipe: THandle;
  hStdInReadPipe, hStdInWritePipe, hStdInWritePipeDup: THandle;
  hErrReadPipe, hErrWritePipe: THandle;
  sa: TSecurityAttributes;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  bufStdIn: array[0..8192] of Byte;
  dwRet: DWord;
  StreamBufferSize, nWritten: DWord;
  ch: String;
  ec: Cardinal;
begin
  if (CommandLine = '') or (StdOut = nil) then exit;

  with sa do
  begin
    nLength := sizeof(TSecurityAttributes);
    lpSecurityDescriptor := nil;
    bInheritHandle := true;
  end;

  hReadPipe := 0; hWritePipe := 0;
  hErrReadPipe := 0; hErrWritePipe := 0;

  if (StdIn <> nil) then
  begin
    StdInReading := 0;
  end;

  CreatePipe(hStdInReadPipe, hStdInWritePipe, @sa, 8192);
  DuplicateHandle(GetCurrentProcess(), hStdInWritePipe, GetCurrentProcess(),
                  @hStdInWritePipeDup, 0, false, DUPLICATE_SAME_ACCESS);
  CloseHandle(hStdInWritePipe);

  CreatePipe(hReadPipe, hWritePipe, @sa, 8192);
  ProcessInfo.hProcess := 0;
  ec := 0;
  WatchDog := GetTickCount();
  try
    CreatePipe(hErrReadPipe, hErrWritePipe, @sa, 8192);
    try
      ZeroMemory(@StartupInfo, sizeof(TStartupInfo));
      with StartupInfo do
      begin
        cb := sizeof(TStartupInfo);
        dwFlags := STARTF_USESTDHANDLES;
        // ꂪȂ DOS \Ă܂
        wShowWindow := SW_HIDE;
        // W IO ɃpCv̒[w肵Ă
        hStdInput  := hStdInReadPipe;
        hStdOutput := hWritePipe;
        hStdError  := hErrWritePipe;
      end;

      // R\[AvN
      if CreateProcess(nil, PChar(CommandLine), @sa, nil, true, DETACHED_PROCESS,
                      nil, nil, StartupInfo, ProcessInfo) = true then
      begin
        // vZXDxύX
        SetPriorityClass(ProcessInfo.hProcess, Priority);

        // ͑҂ɂȂ܂ő҂ĂC
        WaitForInputIdle(ProcessInfo.hProcess, 1000);
        StdOut.Clear;
        try
          repeat
            Sleep(50);

            // W̓pCv̓e𒲂ׂ
            if (StdIn <> nil) then
            begin
              StreamBufferSize := 8192;
              while StreamBufferSize = 8192 do
              begin
                StreamBufferSize := 0;
                while (StdInReading < StdIn.Size) and (StreamBufferSize<8192) do
                begin
                  ch := PChar(StdIn.Memory)[StdInReading];
                  bufStdIn[StreamBufferSize] := ord(ch[1]);
                  StreamBufferSize := StreamBufferSize + 1;
                  StdInReading     := StdInReading     + 1;
                end;
                WriteFile(hStdInWritePipeDup, bufStdIn, StreamBufferSize, nWritten, nil);
                WatchDog := GetTickCount();
              end;
            end;

            // Wo̓pCv̓e𒲂ׂ
            PeekNamedPipe(hReadPipe, nil, 0, nil, @dwStdOut, nil);
            if (dwStdOut > 0) then
            begin
              // e݂΁Aǂݎ
              ReadFile(hReadPipe, bufStdOut, Length(bufStdOut) - 1, dwStdOut, nil);
              Synchronize(WriteStdOut);
              WatchDog := GetTickCount();
            end;

            // lɃG[o͂̏
            PeekNamedPipe(hErrReadPipe, nil, 0, nil, @dwErrOut, nil);
            if (dwErrOut > 0) then
            begin
              // e݂΁Aǂݎ
              ReadFile(hErrReadPipe, bufErrOut, Length(bufErrOut) - 1, dwErrOut, nil);
              Synchronize(WriteErrOut);
              WatchDog := GetTickCount();
            end;

            // EHb`hOiȂ狭Ij
            if ((GetTickCount()-WatchDog)>WatchDogTimeOut) then
            begin
              // I
              TerminateProcess(ProcessInfo.hProcess,9999);
            end;

            // XbhIȂvZXI
            if (Terminated) then
            begin
              TerminateProcess(ProcessInfo.hProcess, 0);
            end;

            dwRet := WaitForSingleObject(ProcessInfo.hProcess, 0);
          until (dwRet = WAIT_OBJECT_0);        // R\[AṽvZX݂Ă
          // IR[h𓾂
          GetExitCodeProcess(ProcessInfo.hProcess, ec);
        finally
          CloseHandle(ProcessInfo.hProcess);
          CloseHandle(ProcessInfo.hThread);
          CloseHandle(hStdInWritePipeDup);
          CloseHandle(hStdInReadPipe);
        end;
      end;
    finally
      CloseHandle(hErrReadPipe);
      CloseHandle(hErrWritePipe);
    end;
  finally
    if (ProcessInfo.hProcess <> 0) then
    begin
      dwRet := WaitForSingleObject(ProcessInfo.hProcess, 0);
      if (dwRet <> WAIT_OBJECT_0) then
      begin
        TerminateProcess(ProcessInfo.hProcess, 0);
      end;
    end;
    CloseHandle(hReadPipe);
    CloseHandle(hWritePipe);
  end;

  // IR[hԂ
  ErrCode := ec;
  Synchronize(ErrorSignal);
end;

end.
