unit pOneSegWWW_Trans;

{$WARN UNIT_PLATFORM OFF}
{$WARN SYMBOL_PLATFORM OFF}
{$WARN SYMBOL_DEPRECATED OFF}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, INIFiles, Taskbar, ExtCtrls, Menus, StdCtrls, pFFMpeg, DateUtils;


const
  ININame = 'OneSegWWW.INI';

type
  TTransForm = class(TForm)
    TransTimer: TTimer;
    TrayIcon1: TTrayIcon;
    PopupMenu1: TPopupMenu;
    W1: TMenuItem;
    X1: TMenuItem;
    Label1: TLabel;
    LogEdit: TEdit;
    ExpireTimer: TTimer;
    WatchTimer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure TrayIcon1DblClick(Sender: TObject);
    procedure X1Click(Sender: TObject);
    procedure TransTimerTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ExpireTimerTimer(Sender: TObject);
    procedure WatchTimerTimer(Sender: TObject);
  private
    { Private 錾 }
    ConvertList     :String;
    LogFolder       :String;
    FlvFolder       :String;
    TransExe        :String;
    ExtractExe      :String;
    RecorderExe     :String;
    Expire          :Integer;
    CheckRecorder   :Boolean;
    ExtractThread   :Tffmpeg;
    RequestURL      :String;
    RcvLine         :String;
    BefCR           :String;
    WatchDogTimeOut :DWord;
    procedure LogOut(Req:String; Log:String);
    procedure FinishThread(Sender: TObject);
    procedure ExecuteProgError(Sender: TObject; ErrorCode: Integer);
    procedure StopThread;
    procedure GetStdOut(Sender: TObject);
  public
    { Public 錾 }
  end;

var
  TransForm: TTransForm;

implementation

{$R *.dfm}

procedure TTransForm.FormCreate(Sender: TObject);
var
  INI: TINIFile;
begin
  ExtractThread  := nil;
  RequestURL     := '';
  RcvLine        := '';
  BefCR          := '';

  INI := TINIFile.Create(IncludeTrailingPathDelimiter(ExtractFilePath(Application.ExeName))+ININame);
  try
    ConvertList     := INI.ReadString ('Config','ConvertList','');
    LogFolder       := INI.ReadString ('Config','LogFolder','');
    FlvFolder       := INI.ReadString ('Config','FlvFolder','');
    Expire          := INI.ReadInteger('Config','CacheExpire',10);
    CheckRecorder   := INI.ReadBool   ('Config','CheckRecorder',False);
    WatchDogTimeOut := INI.ReadInteger('Config','WatchDogTimeOut',20)*1000;

    TransExe        := INI.ReadString('Exe','Trans','');
    ExtractExe      := INI.ReadString('Exe','Extract','');
    RecorderExe     := INI.ReadString('Exe','Recorder','');
  finally
    INI.Free;
  end;
  if (ConvertList='') or (LogFolder='') or (FlvFolder='') or (not FileExists(ExtractExe)) then
  begin
    Application.Terminate;
  end
    else
  begin
    if (not DirectoryExists(LogFolder)) or (not DirectoryExists(FlvFolder)) then
    begin
      Application.Terminate;
    end;
  end;
  Application.Minimize;
  inherited;
  LogEdit.Text := ConvertList;
end;

procedure TTransForm.TrayIcon1DblClick(Sender: TObject);
begin
  Application.Restore;
end;

procedure TTransForm.X1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TTransForm.LogOut(Req:String; Log:String);
var
  LogFName : String;
  Lst : TStringList;
begin
  LogFName := IncludeTrailingPathDelimiter(LogFolder)+Req+'.log';
  Lst := TStringList.Create;
  if FileExists(LogFName) then Lst.LoadFromFile(LogFName);
  // MP4Box̃vOX\̏ꍇ͍ŏIs㏑
  if ((Copy(Log,1,9)='Importing') or (Copy(Log,1,8)='ISO File')) then
  begin
    if (Lst.Count>0) then
    begin
      if (Copy(Log,1,8)=Copy(Lst[Lst.Count-1],1,8)) then Lst.Delete(Lst.Count-1);
    end;
  end;
  Lst.Add(Log);
  Lst.SaveToFile(LogFName);
end;

procedure TTransForm.TransTimerTimer(Sender: TObject);
var
  Lst      : TStringList;
  Req,ExtReq,str  : String;
  Channel                  : Integer;
  FromDate,FromTime,ToTime : TDateTime;
  DateFmt     : TFormatSettings;
  ffmpeg: TFFmpeg;
begin
  if not Assigned(ExtractThread) then
  begin
    // NGXg擪`FbN
    Req := '';
    if FileExists(ConvertList) then
    begin
      Lst := TStringList.Create;
      Lst.LoadFromFile(ConvertList);
      if (Lst.Count>0) then
      begin
        Req := Lst[0];
        Lst.Delete(0);
        Lst.SaveToFile(ConvertList);
      end;
      if (Lst.Count=0) then
      begin
        DeleteFile(ConvertList);
      end;
    end;

    // ϊvZX
    if (Req<>'') then
    begin
      // KeXg
      try
        DateFmt.ShortDateFormat := 'yymmdd';
        DateFmt.ShortTimeFormat := 'hhnnss';
        FromDate := EncodeDate(StrToIntDef(Copy(Req,1,2),-1)+2000,StrToIntDef(Copy(Req,3,2),-1),StrToIntDef(Copy(Req,5,2),-1));
        FromTime := EncodeTime(StrToIntDef(Copy(Req,8,2),-1),StrToIntDef(Copy(Req,10,2),-1),StrToIntDef(Copy(Req,12,2),-1),0);
        ToTime   := EncodeTime(StrToIntDef(Copy(Req,15,2),-1),StrToIntDef(Copy(Req,17,2),-1),StrToIntDef(Copy(Req,19,2),-1),0);
        Channel  := StrToIntDef(Copy(Req,22,Length(Req)),-1);
        //
        if (Channel>0) then
        begin
          // NGXg쐬
          RequestURL := Req;
          DateTimeToString(str,'yy/mm/dd hh:nn:ss',(FromDate+FromTime));
          ExtReq := str;
          DateTimeToString(str,'hh:nn:ss',ToTime);
          ExtReq := ExtReq+' '+str+' '+IntToStr(Channel)+' "'+IncludeTrailingPathDelimiter(FlvFolder)+Req+'.flv"';

          // R}hN
          ffmpeg := TFFmpeg.Create(True);
          ffmpeg.FreeOnTerminate := True;
          ffmpeg.StdIn           := TMemoryStream.Create;
          ffmpeg.StdInReading    := 0;
          ffmpeg.StdOut          := TMemoryStream.Create;
          ffmpeg.StdOutReading   := 0;
          ffmpeg.CommandLine     := '"'+ExtractExe+'" '+ExtReq;
          ffmpeg.OnTerminate     := FinishThread;
          ffmpeg.OnErrorSignal   := ExecuteProgError;
          ffmpeg.OnWriteStdOut   := GetStdOut;
          ffmpeg.Priority        := NORMAL_PRIORITY_CLASS;
          ffmpeg.WatchDogTimeOut := WatchDogTimeOut;
          ExtractThread := ffmpeg;
          RcvLine := '';
          ffmpeg.Resume;
        end;
      except
        LogOut(RequestURL,'G[܂');
      end;
    end;
  end;
end;


// ---------------------------------------------------------
//   OvOXbhI
// ---------------------------------------------------------

procedure TTransForm.FinishThread(Sender: TObject);
begin
  RequestURL    := '';
  ExtractThread := nil;
end;

procedure TTransForm.ExecuteProgError(Sender: TObject; ErrorCode: Integer);
var
  LogFName: String;
  i: Integer;
begin
  if (RequestURL<>'') then
  begin
    if (ErrorCode <> 0) then
    begin
      LogOut(RequestURL,'[Error:'+IntToStr(ErrorCode)+']');
    end
      else
    begin
      LogFName := IncludeTrailingPathDelimiter(LogFolder)+RequestURL+'.log';
      i := 0;
      while FileExists(LogFName) do
      begin
        DeleteFile(LogFName);
        i := i + 1; if (i>5) then break;
        if FileExists(LogFName) then Sleep(100);
      end;
    end;
  end;
end;

procedure TTransForm.StopThread;
begin
  if Assigned(ExtractThread) then
  begin
    ExtractThread.Terminate;
  end;

  while Assigned(ExtractThread) do
  begin
    Application.ProcessMessages;
  end;
end;

procedure TTransForm.GetStdOut(Sender: TObject);
var
  p:  PChar;
  ch: String;
begin
  if Assigned(ExtractThread) then
  begin
    while (ExtractThread.StdOutReading < ExtractThread.StdOut.Size) do
    begin
      p  := ExtractThread.StdOut.Memory;
      ch := p[ExtractThread.StdOutReading];
      ExtractThread.StdOutReading := ExtractThread.StdOutReading + 1;

      if ((ch = #13) or (ch = #10)) then
      begin
        if not ((ch = #10) and (BefCR = #13)) then
        begin
          if (RequestURL<>'') then LogOut(RequestURL,RcvLine);
          RcvLine := '';
          BefCR := ch;
        end;
      end
        else
      begin
        if (ord(ch[1]) >= 32) then
        begin
          RcvLine := RcvLine + ch;
        end;
        BefCR := '';
      end;
    end;
  end;
end;

procedure TTransForm.FormDestroy(Sender: TObject);
begin
  StopThread;
end;


// ------------------------------------------
//   LbV̗L؂`FbN
// ------------------------------------------

procedure TTransForm.ExpireTimerTimer(Sender: TObject);
var
  sr: TSearchRec;
begin
  // flvt@C
  if FindFirst(IncludeTrailingPathDelimiter(FlvFolder)+'*.flv', faReadOnly or faHidden or faArchive, sr) = 0 then
  begin
    repeat
      if (IncMinute(FileDateToDateTime(sr.Time),Expire)<Now) then
      begin
        DeleteFile(IncludeTrailingPathDelimiter(FlvFolder)+sr.Name);
      end;
    until FindNext(sr) <> 0;
    FindClose(sr);
  end;

  // logt@C
  if FindFirst(IncludeTrailingPathDelimiter(LogFolder)+'*.log', faReadOnly or faHidden or faArchive, sr) = 0 then
  begin
    repeat
      if (IncMinute(FileDateToDateTime(sr.Time),Expire)<Now) then
      begin
        DeleteFile(IncludeTrailingPathDelimiter(LogFolder)+sr.Name);
      end;
    until FindNext(sr) <> 0;
    FindClose(sr);
  end;
end;

procedure TTransForm.WatchTimerTimer(Sender: TObject);
const
  MutexName = 'OneSegRec24';
var
  hMutex: THANDLE;
  pi: TProcessInformation;
  si: TStartupInfo;
begin
  if (CheckRecorder) then
  begin
    hMutex := OpenMutex(MUTEX_ALL_ACCESS, False, MutexName+'Mutex');
    if (hMutex=0) then
    begin
      // ȂN
      GetStartupInfo(si) ;
      CreateProcess(nil,PChar(RecorderExe),nil,nil,False,
        CREATE_DEFAULT_ERROR_MODE,nil,PChar(GetCurrentDir),si,pi);
    end
      else
    begin
      CloseHandle(hMutex);
    end;
  end;
end;

end.
