program OneSeg_Extract;

{$APPTYPE CONSOLE}

uses
  SysUtils,Classes,DateUtils,Windows,INIFiles,Variants,XMLDoc,XMLIntf,ActiveX,
  StdCtrls,StrUtils;


const
  MAXPID    = 64;
  NULL_PID  = -1;
  MP4BOX    = 'MP4Box.exe';

type
  TTSHeader = record
    sync_byte                    : Integer;
    transport_error_indicator    : Integer;
    payload_unit_start_indicator : Integer;
    transport_priority           : Integer;
    PID                          : Integer;
    transport_scrambling_control : Integer;
    adaptation_field_control     : Integer;
    continuity_counter           : Integer;
  end;

  TPESHeader = record
    packet_start_code_prefix     : Integer;
    stream_id                    : Integer;
    PES_packet_length            : Integer;

    PES_scrambling_control       : Integer;
    PES_priority                 : Integer;
    data_alignment_indicator     : Integer;
    copyright                    : Integer;
    original_or_copy             : Integer;
    PTS_DTS_flags                : Integer;
    ESCR_flag                    : Integer;
    ES_rate_flag                 : Integer;
    DSM_trick_mode_flag          : Integer;
    additional_copy_info_flag    : Integer;
    PES_CRC_flag                 : Integer;
    PES_extension_flag           : Integer;
    PES_header_data_length       : Integer;

    PTS1                         : Integer;
    PTS2                         : Integer;
    PTS3                         : Integer;
    PTS                          : Int64;
    DTS1                         : Integer;
    DTS2                         : Integer;
    DTS3                         : Integer;
    DTS                          : Int64;
    ESCR_base1                   : Integer;
    ESCR_base2                   : Integer;
    ESCR_base3                   : Integer;
    ESCR_extension               : Integer;
    ES_rate                      : Integer;
    trick_mode_control           : Integer;
    trick_mode_data              : Integer;
    additional_copy_info         : Integer;
    previous_PES_packet_CRC      : Integer;

    PES_private_data_flag        : Integer;
    pack_header_field_flag       : Integer;
    program_packet_sequence_counter_flag : Integer;
    P_STD_buffer_flag            : Integer;
    PES_extension_flag_2         : Integer;
    PES_private_data             : array[0..15] of Char;
    pack_field_length            : Integer;
    pack_header                  : array[0..255] of Char;
    program_packet_sequence_counter : Integer;
    MPEG1_MPEG2_identifier       : Integer;
    original_stuff_length        : Integer;
    P_STD_buffer_scale           : Integer;
    P_STD_buffer_size            : Integer;
    PES_extension_field_length   : Integer;
    PES_extension_field          : array[0..127] of Char;
  end;


  TEStream = record
    PID          : Integer;
    MaxSize      : Int64;
    Position     : Int64;
    LastCounter  : Integer;
    PESHeader    : TPESHeader;
    Data         : array of char;
  end;

var
  EStream         : array [0..(MAXPID-1)] of TEStream;
  VideoPID        : Integer;
  AudioPID        : Integer;
  VideoFile       : TStream;
  AudioFile       : TStream;
  VideoPTS        : Int64;
  AudioPTS        : Int64;
  LastVideoPTS    : Int64;
  LastAudioPTS    : Int64;
  ForceVideoFirst : Boolean;
  WatchDogTimeOut : DWord;



// ----------------------------
//   OR}h̎s
// ----------------------------
function ExecuteEXE(cmd,param:String):Boolean;
var
  hReadPipe, hWritePipe: THandle;
  hStdInReadPipe, hStdInWritePipe, hStdInWritePipeDup: THandle;
  hErrReadPipe, hErrWritePipe: THandle;
  sa: TSecurityAttributes;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  dwRet: DWord;
  ec: Cardinal;
  bufStdOut,bufErrOut : array[0..8192] of Char;
  dwStdOut ,dwErrOut  : DWord;
  dwWatchDog: DWord;
begin
  with sa do
  begin
    nLength := sizeof(TSecurityAttributes);
    lpSecurityDescriptor := nil;
    bInheritHandle := true;
  end;

  hReadPipe := 0; hWritePipe := 0;
  hErrReadPipe := 0; hErrWritePipe := 0;

  CreatePipe(hStdInReadPipe, hStdInWritePipe, @sa, 8192);
  DuplicateHandle(GetCurrentProcess(), hStdInWritePipe, GetCurrentProcess(),
                  @hStdInWritePipeDup, 0, false, DUPLICATE_SAME_ACCESS);
  CloseHandle(hStdInWritePipe);

  CreatePipe(hReadPipe, hWritePipe, @sa, 8192);
  ProcessInfo.hProcess := 0;
  ec := 0;
  dwWatchDog := GetTickCount();
  try
    CreatePipe(hErrReadPipe, hErrWritePipe, @sa, 8192);
    try
      ZeroMemory(@StartupInfo, sizeof(TStartupInfo));
      with StartupInfo do
      begin
        cb := sizeof(TStartupInfo);
        dwFlags := STARTF_USESTDHANDLES;
        // ꂪȂ DOS \Ă܂
        wShowWindow := SW_HIDE;
        // W IO ɃpCv̒[w肵Ă
        hStdInput  := hStdInReadPipe;
        hStdOutput := hWritePipe;
        hStdError  := hErrWritePipe;
      end;

      // R\[AvN
      if CreateProcess(nil, PChar('"'+cmd+'" '+param), @sa, nil, true, DETACHED_PROCESS,
                      nil, nil, StartupInfo, ProcessInfo) = true then
      begin
        // vZXDxύX
        SetPriorityClass(ProcessInfo.hProcess, NORMAL_PRIORITY_CLASS);

        // ͑҂ɂȂ܂ő҂ĂC
        WaitForInputIdle(ProcessInfo.hProcess, 1000);
        try
          repeat
            Sleep(50);

            // Wo̓pCv̓e𒲂ׂ
            PeekNamedPipe(hReadPipe, nil, 0, nil, @dwStdOut, nil);
            if (dwStdOut > 0) then
            begin
              // e݂΁Aǂݎ
              ReadFile(hReadPipe, bufStdOut, Length(bufStdOut) - 1, dwStdOut, nil);
              Write(Copy(String(bufStdOut),1,dwStdOut));
              dwWatchDog := GetTickCount();
            end;

            // lɃG[o͂̏
            PeekNamedPipe(hErrReadPipe, nil, 0, nil, @dwErrOut, nil);
            if (dwErrOut > 0) then
            begin
              // e݂΁Aǂݎ
              ReadFile(hErrReadPipe, bufErrOut, Length(bufErrOut) - 1, dwErrOut, nil);
              Write(Copy(String(bufErrOut),1,dwErrOut));
              dwWatchDog := GetTickCount();
            end;

            dwRet := WaitForSingleObject(ProcessInfo.hProcess, 0);

            // EHb`hOiȂ狭Ij
            if ((GetTickCount()-dwWatchDog)>WatchDogTimeOut) then
            begin
              // I
              TerminateProcess(ProcessInfo.hProcess,9999);
              Write('***** WATCHDOG Timeout. Terminate process *****');
            end;
          until (dwRet = WAIT_OBJECT_0);        // R\[AṽvZX݂Ă
          // IR[h𓾂
          GetExitCodeProcess(ProcessInfo.hProcess, ec);
        finally
          CloseHandle(ProcessInfo.hProcess);
          CloseHandle(ProcessInfo.hThread);
          CloseHandle(hStdInWritePipeDup);
          CloseHandle(hStdInReadPipe);
        end;
      end;
    finally
      CloseHandle(hErrReadPipe);
      CloseHandle(hErrWritePipe);
    end;
  finally
    if (ProcessInfo.hProcess <> 0) then
    begin
      dwRet := WaitForSingleObject(ProcessInfo.hProcess, 0);
      if (dwRet <> WAIT_OBJECT_0) then
      begin
        TerminateProcess(ProcessInfo.hProcess, 0);
      end;
    end;
    CloseHandle(hReadPipe);
    CloseHandle(hWritePipe);
  end;

  // IR[hԂ
  Result := (ec<>0);
end;


// ----------------------------
//   PESo
// ----------------------------

procedure WritePES(var ES:TEStream);
begin
  if (VideoPID = 0) then
  begin
    // Video?
    if ((ES.PESHeader.stream_id and $F0) = $E0) then VideoPID := ES.PID;
  end
    else
  begin
    if (((ES.PESHeader.stream_id and $F0) = $E0) and (VideoPID <> ES.PID)) then
    begin
      writeln('Other Video PID Found:'+IntToStr(ES.PID));
    end;
  end;

  if (AudioPID = 0) then
  begin
    // Audio?
    if ((ES.PESHeader.stream_id and $E0) = $C0) then AudioPID := ES.PID;
  end
    else
  begin
    if (((ES.PESHeader.stream_id and $F0) = $C0) and (AudioPID <> ES.PID)) then
    begin
      writeln('Other Audio PID Found:'+IntToStr(ES.PID));
    end;
  end;

  // Write Stream
  if (VideoPID = ES.PID) then
  begin
    if Assigned(VideoFile) then
    begin
      VideoFile.Write(ES.Data[0],ES.Position);
      // PTS Check
      if (LastVideoPTS>0) then
      begin
//        writeln('PTS Diff:'+IntToStr((ES.PESHeader.PTS-LastAudioPTS) div 90));
      end;
      LastVideoPTS := ES.PESHeader.PTS;
      if (VideoPTS = -2) then
      begin
        VideoPTS := ES.PESHeader.PTS;
      end;
    end;
  end;
  if (AudioPID = ES.PID) then
  begin
    if Assigned(AudioFile) then
    begin
      if (not ForceVideoFirst) or (ES.PESHeader.PTS<0) or ((ES.PESHeader.PTS>VideoPTS) and (VideoPTS>=0)) then
      begin
        AudioFile.Write(ES.Data[0],ES.Position);
        // PTS Check
        if (LastAudioPTS>0) then
        begin
//          writeln('PTS Diff:'+IntToStr((ES.PESHeader.PTS-LastVideoPTS) div 90));
        end;
        LastAudioPTS := ES.PESHeader.PTS;
        if (AudioPTS = -2) then
        begin
          AudioPTS := ES.PESHeader.PTS;
        end;
      end;
    end;
  end;
end;
// 183721, -172201


// ----------------------------
//   TOTpPbg
// ----------------------------

function AnalyzeTOT(buf:PChar; tot:PChar): TDateTime;
var
  ptr,ptr2,i  : Integer;
  table_id    : BYTE;
  sect_len    : WORD;
  mjd         : Integer;
  h,m,s       : Integer;
  ch          : BYTE;
begin
  Result := 0;
  //
  ptr := 5;
  //
  repeat
    table_id := ord(buf[ptr]);
    ptr := ptr + 1;
    if (table_id <> $FF) then
    begin
      sect_len := (ord(buf[ptr])*256 + ord(buf[ptr+1])) and $0FFF;
      ptr  := ptr + 2;
      ptr2 := ptr;

      case table_id of
      $73:
        begin
          // TOT
          mjd := (ord(buf[ptr2])*256 + ord(buf[ptr2+1]));
          ch := ord(buf[ptr2+2]); h := (ch shr 4)*10 + (ch and $F);
          ch := ord(buf[ptr2+3]); m := (ch shr 4)*10 + (ch and $F);
          ch := ord(buf[ptr2+4]); s := (ch shr 4)*10 + (ch and $F);
          Result := ModifiedJulianDateToDateTime(mjd) + EncodeTime(h,m,s,0);
          for i:=0 to 4 do tot[i] := buf[ptr2+i];
        end;
      end;
      ptr := ptr + sect_len;
    end;
  until ((ptr>=188) or (table_id = $FF));
end;

function DateTimeToFullPath(Base:String; Ch:Integer; tm: TDateTime):String;
var
  str,datstr: String;
begin
  DateTimeToString(str   ,'yymmddhh',tm);
  DateTimeToString(datstr,'yymmdd'  ,tm);
  Result := IncludeTrailingPathDelimiter(Base)+datstr+PathDelim+str+'_Ch'+IntToStr(Ch);
end;

function HourFileExists(Base:String; Ch:Integer; tm: TDateTime):Boolean;
begin
  Result := FileExists(DateTimeToFullPath(Base,Ch,tm)+'.idx');
end;

function TOTtoDateTime(totcode:PChar):TDateTime;
var
  mjd         : Integer;
  h,m,s       : Integer;
  ch          : BYTE;
begin
  mjd := (ord(totcode[0])*256 + ord(totcode[1]));
  ch  := ord(totcode[2]); h := (ch shr 4)*10 + (ch and $F);
  ch  := ord(totcode[3]); m := (ch shr 4)*10 + (ch and $F);
  ch  := ord(totcode[4]); s := (ch shr 4)*10 + (ch and $F);
  Result := ModifiedJulianDateToDateTime(mjd) + EncodeTime(h,m,s,0);
end;




// ----------------------------
//   rbgǂݏo
// ----------------------------

function GetBits(buf:PChar; var ptr_byte:Integer; var ptr_bit:Integer; bits:Integer): Int64;
var
  res1,res2: Int64;
  ch: Byte;
  i: Integer;
begin
  res1 := 1; for i:=1 to (bits-1) do res1 := res1 * 2;
  res2 := 0;

  ch := ord(buf[ptr_byte]);

  while(bits>0) do
  begin
    if ((ch and (1 shl (7-ptr_bit)))<>0) then res2 := res2 + res1;
    res1 := res1 div 2;
    ptr_bit := ptr_bit + 1;
    if (ptr_bit = 8) then
    begin
      ptr_bit  := 0;
      ptr_byte := ptr_byte + 1;
      ch := ord(buf[ptr_byte]);
    end;
    bits := bits - 1;
  end;
  Result := res2;
end;


// ----------------------------
//   PIDES
// ----------------------------

function PIDtoES(PID:Integer): Integer;
var
  i: Integer;
begin
  Result := NULL_PID;
  for i:=0 to (MAXPID-1) do
  begin
    if (EStream[i].PID = PID) then
    begin
      Result := i;
    end;
  end;
end;



// ----------------------------
//   TSpPbg
// ----------------------------

procedure AnalyzeTS(buf:PChar);
var
  ptr_byte,ptr_bit        : Integer;
  TSH                     : TTSHeader;
  adaptation_field_length : Integer;
  es                      : Integer;
  payload_ptr,i,len       : Integer;
begin
  ptr_byte := 0;
  ptr_bit  := 0;
  //
  TSH.sync_byte                    := GetBits(buf,ptr_byte,ptr_bit,8);
  TSH.transport_error_indicator    := GetBits(buf,ptr_byte,ptr_bit,1);
  TSH.payload_unit_start_indicator := GetBits(buf,ptr_byte,ptr_bit,1);
  TSH.transport_priority           := GetBits(buf,ptr_byte,ptr_bit,1);
  TSH.PID                          := GetBits(buf,ptr_byte,ptr_bit,13);
  TSH.transport_scrambling_control := GetBits(buf,ptr_byte,ptr_bit,2);
  TSH.adaptation_field_control     := GetBits(buf,ptr_byte,ptr_bit,2);
  TSH.continuity_counter           := GetBits(buf,ptr_byte,ptr_bit,4);
  //
  if (TSH.PID = $1FFF) then
  begin
    // Padding
    es := NULL_PID;
  end
    else
  begin
    es := PIDtoES(TSH.PID);
    if (es=NULL_PID) then
    begin
      if (TSH.payload_unit_start_indicator<>0) then
      begin
        // VKES
        es := PIDtoES(NULL_PID);
        EStream[es].PID         := TSH.PID;
        EStream[es].MaxSize     := 0;
        EStream[es].Position    := 0;
        EStream[es].LastCounter := (TSH.continuity_counter-1) and $0F;
      end;
    end
      else
    begin
      // ES
      if (TSH.payload_unit_start_indicator<>0) then
      begin
        // OPESo
        WritePES(EStream[es]);

        // PES
        setLength(EStream[es].Data,0);
        EStream[es].PID         := TSH.PID;
        EStream[es].MaxSize     := 0;
        EStream[es].Position    := 0;
        EStream[es].LastCounter := (TSH.continuity_counter-1) and $0F;
      end;
    end;
  end;

  if (es<>NULL_PID) then
  begin
    if (((EStream[es].LastCounter+1) and $0F)<>TSH.continuity_counter) then
    begin
      // psihbvj
      writeln('PID:'+IntToHex(TSH.PID,4)+' Drop Packet');
      flush(Output);
    end;
    EStream[es].LastCounter := TSH.continuity_counter;

    if (TSH.adaptation_field_control = 2) or (TSH.adaptation_field_control = 3) then
    begin
      // adaptation_field
      adaptation_field_length := GetBits(buf,ptr_byte,ptr_bit,8);
      ptr_byte := ptr_byte + adaptation_field_length;
    end;

    if (TSH.adaptation_field_control = 1) or (TSH.adaptation_field_control = 3) then
    begin
      // payload
      if (TSH.payload_unit_start_indicator <> 0) then
      begin
        // PES Header
        with EStream[es].PESHeader do
        begin
          payload_ptr                := ptr_byte;
          PES_packet_length          := 0;
          packet_start_code_prefix := GetBits(buf,ptr_byte,ptr_bit,24);

          if (packet_start_code_prefix = $0001) then
          begin
            stream_id                := GetBits(buf,ptr_byte,ptr_bit,8);
            PES_packet_length        := GetBits(buf,ptr_byte,ptr_bit,16);
            payload_ptr              := ptr_byte;
            if ( (stream_id <> $BC) and
                 (stream_id <> $BE) and
                 (stream_id <> $BF) and
                 (stream_id <> $F0) and
                 (stream_id <> $F1) and
                 (stream_id <> $FF) and
                 (stream_id <> $F2) and
                 (stream_id <> $F8) ) then
            begin
              GetBits(buf,ptr_byte,ptr_bit,2);
              PES_scrambling_control    := GetBits(buf,ptr_byte,ptr_bit,2);
              PES_priority              := GetBits(buf,ptr_byte,ptr_bit,1);
              data_alignment_indicator  := GetBits(buf,ptr_byte,ptr_bit,1);
              copyright                 := GetBits(buf,ptr_byte,ptr_bit,1);
              original_or_copy          := GetBits(buf,ptr_byte,ptr_bit,1);
              PTS_DTS_flags             := GetBits(buf,ptr_byte,ptr_bit,2);
              ESCR_flag                 := GetBits(buf,ptr_byte,ptr_bit,1);
              ES_rate_flag              := GetBits(buf,ptr_byte,ptr_bit,1);
              DSM_trick_mode_flag       := GetBits(buf,ptr_byte,ptr_bit,1);
              additional_copy_info_flag := GetBits(buf,ptr_byte,ptr_bit,1);
              PES_CRC_flag              := GetBits(buf,ptr_byte,ptr_bit,1);
              PES_extension_flag        := GetBits(buf,ptr_byte,ptr_bit,1);
              PES_header_data_length    := GetBits(buf,ptr_byte,ptr_bit,8);
              payload_ptr               := ptr_byte + PES_header_data_length;
              PTS                       := -1;
              DTS                       := -1;
              //
              if ((PTS_DTS_flags and 2)<>0) then
              begin
                GetBits(buf,ptr_byte,ptr_bit,4);
                PTS1                    := GetBits(buf,ptr_byte,ptr_bit,3);
                GetBits(buf,ptr_byte,ptr_bit,1);
                PTS2                    := GetBits(buf,ptr_byte,ptr_bit,15);
                GetBits(buf,ptr_byte,ptr_bit,1);
                PTS3                    := GetBits(buf,ptr_byte,ptr_bit,15);
                GetBits(buf,ptr_byte,ptr_bit,1);
                PTS  := Int64(PTS1)*Int64(32768)*Int64(32768)+Int64(PTS2)*Int64(32768)+Int64(PTS3);
              end;
              if ((PTS_DTS_flags and 1)<>0) then
              begin
                GetBits(buf,ptr_byte,ptr_bit,4);
                DTS1                    := GetBits(buf,ptr_byte,ptr_bit,3);
                GetBits(buf,ptr_byte,ptr_bit,1);
                DTS2                    := GetBits(buf,ptr_byte,ptr_bit,15);
                GetBits(buf,ptr_byte,ptr_bit,1);
                DTS3                    := GetBits(buf,ptr_byte,ptr_bit,15);
                GetBits(buf,ptr_byte,ptr_bit,1);
                DTS  := Int64(DTS1)*Int64(32768)*Int64(32768)+Int64(DTS2)*Int64(32768)+Int64(DTS3);
              end;
              if (ESCR_flag <> 0) then
              begin
                GetBits(buf,ptr_byte,ptr_bit,2);
                ESCR_base1              := GetBits(buf,ptr_byte,ptr_bit,3);
                GetBits(buf,ptr_byte,ptr_bit,1);
                ESCR_base2              := GetBits(buf,ptr_byte,ptr_bit,15);
                GetBits(buf,ptr_byte,ptr_bit,1);
                ESCR_base3              := GetBits(buf,ptr_byte,ptr_bit,15);
                GetBits(buf,ptr_byte,ptr_bit,1);
                ESCR_extension          := GetBits(buf,ptr_byte,ptr_bit,9);
                GetBits(buf,ptr_byte,ptr_bit,1);
              end;
              if (ES_rate_flag <> 0) then
              begin
                GetBits(buf,ptr_byte,ptr_bit,1);
                ES_rate                 := GetBits(buf,ptr_byte,ptr_bit,22);
                GetBits(buf,ptr_byte,ptr_bit,1);
              end;
              if (DSM_trick_mode_flag <> 0) then
              begin
                trick_mode_control      := GetBits(buf,ptr_byte,ptr_bit,3);
                trick_mode_data         := GetBits(buf,ptr_byte,ptr_bit,5);
              end;
              if (additional_copy_info_flag <> 0) then
              begin
                GetBits(buf,ptr_byte,ptr_bit,1);
                additional_copy_info    := GetBits(buf,ptr_byte,ptr_bit,7);
              end;
              if (PES_CRC_flag <> 0) then
              begin
                previous_PES_packet_CRC := GetBits(buf,ptr_byte,ptr_bit,16);
              end;
              if (PES_extension_flag <> 0) then
              begin
                PES_private_data_flag   := GetBits(buf,ptr_byte,ptr_bit,1);
                pack_header_field_flag  := GetBits(buf,ptr_byte,ptr_bit,1);
                program_packet_sequence_counter_flag := GetBits(buf,ptr_byte,ptr_bit,1);
                P_STD_buffer_flag       := GetBits(buf,ptr_byte,ptr_bit,1);
                GetBits(buf,ptr_byte,ptr_bit,3);
                PES_extension_flag_2    := GetBits(buf,ptr_byte,ptr_bit,1);
                if (PES_private_data_flag<>0) then
                begin
                  for i:=0 to 15 do
                  begin
                    PES_private_data[i] := buf[ptr_byte+i];
                  end;
                  ptr_byte := ptr_byte + 16;
                end;
                if (pack_header_field_flag<>0) then
                begin
                  pack_field_length     := GetBits(buf,ptr_byte,ptr_bit,8);
                  ptr_byte := ptr_byte + pack_field_length;
                end;
                if (program_packet_sequence_counter_flag<>0) then
                begin
                  GetBits(buf,ptr_byte,ptr_bit,1);
                  program_packet_sequence_counter := GetBits(buf,ptr_byte,ptr_bit,7);
                  GetBits(buf,ptr_byte,ptr_bit,1);
                  MPEG1_MPEG2_identifier          := GetBits(buf,ptr_byte,ptr_bit,1);
                  original_stuff_length           := GetBits(buf,ptr_byte,ptr_bit,6);
                end;
                if (P_STD_buffer_flag<>0) then
                begin
                  GetBits(buf,ptr_byte,ptr_bit,2);
                  P_STD_buffer_scale              := GetBits(buf,ptr_byte,ptr_bit,1);
                  P_STD_buffer_size               := GetBits(buf,ptr_byte,ptr_bit,13);
                end;
                if (PES_extension_flag_2<>0) then
                begin
                  GetBits(buf,ptr_byte,ptr_bit,1);
                  PES_extension_field_length      := GetBits(buf,ptr_byte,ptr_bit,7);
                  for i:=0 to PES_extension_field_length do
                  begin
                    PES_extension_field[i] := buf[ptr_byte+i];
                  end;
                  ptr_byte := ptr_byte + PES_extension_field_length;
                end;
              end;
            end;
          end
            else
          begin
            stream_id                := 0;
          end;
        end;

        // payloadobt@m
        EStream[es].MaxSize  := EStream[es].PESHeader.PES_packet_length;
        EStream[es].Position := 0;
        if (EStream[es].MaxSize = 0) then
        begin
          setLength(EStream[es].Data,65536);
        end
          else
        begin
          setLength(EStream[es].Data,EStream[es].MaxSize);
        end;

        // ŏ̃f[^obt@ɓ
        len := 188-payload_ptr;
        if ((len>EStream[es].MaxSize) and (not (EStream[es].MaxSize=0))) then len := EStream[es].MaxSize;
        if (len>0) then
        begin
          Move(buf[payload_ptr],EStream[es].Data[0],len);
          EStream[es].Position := EStream[es].Position + len;
        end;
      end
        else
      begin
        // ̃pPbg
        len := 188-ptr_byte;
        if (EStream[es].MaxSize = 0) then
        begin
          // s蒷
          if ((EStream[es].Position+len)>=length(EStream[es].Data)) then
          begin
            setLength(EStream[es].Data,length(EStream[es].Data)+65536);
          end;
          Move(buf[ptr_byte],EStream[es].Data[EStream[es].Position],len);
          EStream[es].Position := EStream[es].Position + len;
        end
          else
        begin
          // 蒷
          if ((EStream[es].Position+len)>=EStream[es].MaxSize) then
          begin
            len := EStream[es].MaxSize - EStream[es].Position;
          end;
          Move(buf[ptr_byte],EStream[es].Data[EStream[es].Position],len);
          EStream[es].Position := EStream[es].Position + len;
          //
          if ((EStream[es].Position)>=EStream[es].MaxSize) then
          begin
            // o
            WritePES(EStream[es]);

            // PES
            setLength(EStream[es].Data,0);
            EStream[es].PID         := NULL_PID;
            EStream[es].MaxSize     := 0;
            EStream[es].Position    := 0;
            EStream[es].LastCounter := -1;
          end;
        end;
      end;
    end;
  end;
end;


// ---------------------------------------------------------
//   e|pX̎擾
// ---------------------------------------------------------

function GetTempName: String;
var
  s: String;
  i: Integer;
begin
  s := '';
  for i:=0 to 3 do
  begin
    s := s + IntToHex(Random(65536),4)+IntToHex(Random(65536),4);
    if (i<>3) then s := s + '-';
  end;
  result := s;
end;

function TemporaryPath(Temporary:String): String;
var
  lpPathBuffer : PChar;
begin
  if (Temporary='') or (not DirectoryExists(ExcludeTrailingPathDelimiter(Temporary))) then
  begin
    GetMem(lpPathBuffer, MAX_PATH);
    GetTempPath(MAX_PATH, lpPathBuffer);
    Result := StrPas(lpPathBuffer);
    FreeMem(lpPathBuffer, MAX_PATH);
  end
    else
  begin
    Result := IncludeTrailingPathDelimiter(Temporary);
  end;
end;


// ----------------------------
//   TBF
// ----------------------------

function AnalyzeTBF(fname:String; ProgramCh:TStringList; var FromDate,FromTime,ToDate,ToTime:TDateTime;
                    var Channel:Integer; var Subject:String): Boolean;
var
  i          : Integer;
  XMLd       : IXMLDocument;
  XMLn       : IXMLNode;
  td,tim,dat : String;
begin
  Result := False;
  try
    XMLd := LoadXMLDocument(fname);
    XMLn := XMLd.DocumentElement;
    if (XMLn.NodeName='tbf') then
    begin
      Channel := StrToIntDef(ProgramCh.Values[XMLn.ChildNodes.Nodes['ProgramChannel'].NodeValue],-1);
      td      := XMLn.ChildNodes.Nodes['ProgramStartTime'].NodeValue;
      i       := Pos(' ',td);
      tim     := '';
      dat     := '';
      if (i<>0) then
      begin
        dat := Copy(td,1,i-1);
        tim := Copy(td,i+1,Length(td));
      end;
      FromDate := StrToDate(dat);
      FromTime := StrToTime(tim);

      td      := XMLn.ChildNodes.Nodes['ProgramEndTime'].NodeValue;
      i       := Pos(' ',td);
      tim     := '';
      dat     := '';
      if (i<>0) then
      begin
        dat := Copy(td,1,i-1);
        tim := Copy(td,i+1,Length(td));
      end;
      ToDate  := StrToDate(dat);
      ToTime  := StrToTime(tim);
      //
      Subject := XMLn.ChildNodes.Nodes['ProgramTitle'].NodeValue;
      Result  := True;
    end;
  except
    //
  end;
end;


// ----------------------------
//   TVTL
// ----------------------------

function AnalyzeTVTL(fname:String; StationID:TStringList; TVTLTopic:Boolean;
                     var FromDate,FromTime,ToDate,ToTime:TDateTime;
                     var Channel:Integer; var Subject:String): Boolean;
var
  i          : Integer;
  XMLd       : IXMLDocument;
  XMLn,XMLitm: IXMLNode;
  td,tim,dat : String;
begin
  Result := False;
  try
    XMLd := LoadXMLDocument(fname);
    XMLn := XMLd.DocumentElement;
    if (XMLn.NodeName='tvtl') then
    begin
      XMLitm  := XMLn.ChildNodes.Nodes['item'];
      Channel := StrToIntDef(stationID.Values[XMLitm.ChildNodes.Nodes['stationID'].NodeValue],-1);
      if (TVTLtopic) then
      begin
        td    := XMLitm.ChildNodes.Nodes['topicStartDateTime'].NodeValue;
      end
        else
      begin
        td    := XMLitm.ChildNodes.Nodes['programStartDateTime'].NodeValue;
      end;
      i       := Pos('T',td);
      tim     := '';
      dat     := '';
      if (i<>0) then
      begin
        dat := Copy(td,1,i-1);
        tim := Copy(td,i+1,Length(td));
        i   := Pos('.',tim);
        if (i<>0) then tim := Copy(tim,1,i-1);
        i   := Pos('+',tim);
        if (i<>0) then tim := Copy(tim,1,i-1);
      end;
      dat := AnsiReplaceStr(dat,'-','/');
      FromDate := StrToDate(dat);
      FromTime := StrToTime(tim);

      if (TVTLtopic) then
      begin
        td    := XMLitm.ChildNodes.Nodes['topicEndDateTime'].NodeValue;
      end
        else
      begin
        td    := XMLitm.ChildNodes.Nodes['programEndDateTime'].NodeValue;
      end;
      i       := Pos('T',td);
      tim     := '';
      dat     := '';
      if (i<>0) then
      begin
        dat := Copy(td,1,i-1);
        tim := Copy(td,i+1,Length(td));
        i   := Pos('.',tim);
        if (i<>0) then tim := Copy(tim,1,i-1);
        i   := Pos('+',tim);
        if (i<>0) then tim := Copy(tim,1,i-1);
      end;
      dat := AnsiReplaceStr(dat,'-','/');
      ToDate := StrToDate(dat);
      ToTime := StrToTime(tim);
      //
      Subject := XMLitm.ChildNodes.Nodes['programTitle'].NodeValue;
      Result  := True;
    end;
  except
    //
  end;
end;


// ----------------------------
//   iEPG
// ----------------------------

function AnalyzeiEPG(fname:String; StationID:TStringList;
                     var FromDate,FromTime,ToDate,ToTime:TDateTime;
                     var Channel:Integer; var Subject:String): Boolean;
var
  iEPG : TStringList;
  str  : String;
  y,m,d: Integer;
  st,ed: String;
begin
  Result := False;
  try
    iEPG := TStringList.Create;
    try
      iEPG.NameValueSeparator := ':';
      iEPG.LoadFromFile(fname);
      str := Trim(iEPG.Values['Content-type']);
      if (Pos('application/x-tv-program-info',LowerCase(str))<>0) then
      begin
        // iEPG炵
        Channel  := StrToIntDef(stationID.Values[Trim(iEPG.Values['station'])],-1);
        y        := StrToIntDef(iEPG.Values['year'],YearOf(Now));
        m        := StrToIntDef(iEPG.Values['month'],MonthOf(Now));
        d        := StrToIntDef(iEPG.Values['date'],DayOf(Now));
        st       := Trim(iEPG.Values['start']);
        ed       := Trim(iEPG.Values['end']);
        Subject  := Trim(iEPG.Values['program-title']);
        FromDate := EncodeDate(y,m,d);
        ToDate   := FromDate;
        FromTime := StrToTime(st);
        ToTime   := StrToTime(ed);
        if (FromTime>ToTime) then ToDate := IncDay(ToDate,1);
        Result := True;
      end;
    finally
      iEPG.Free;
    end;
  except
  end;
end;


// ----------------------------
//   C
// ----------------------------

var
  INI         : TINIFile;
  ExeName     : String;
  BasePath    : String;
  OutFolder   : String;
  OutFName    : String;
  VideoFName  : String;
  AudioFName  : String;
  TempFile    : String;
  Temporary   : String;
  ProgramCh   : TStringList;
  StationID   : TStringList;
  FName       : String;
  XMLDone     : Boolean;
  Subject     : String;
  i           : Integer;
  Channel     : Integer;
  FromDate,FromTime,ToDate,ToTime : TDateTime;
  LastTime,IdxTime,NextTime : TDateTime;
  LogTime     : TDateTime;
  buf         : array [0..187] of Char;
  totcode     : array [0..4] of Char;
  Posi,LastPos: DWORD;
  InFile      : TFileStream;
  OutFile     : TFileStream;
  hourcnt     : Integer;
  str         : String;
  tot         : TDateTime;
  pid         : WORD;
  tsmode      : Boolean;
  TVTLtopic   : Boolean;
  Mp4BoxExe   : String;
  delay       : Integer;
  param       : String;
  ErrorFlg    : Boolean;
  DebugMode   : Boolean;
begin
  // --------------------------------
  //   G^Xg[
  // --------------------------------
  for i:=0 to (MAXPID-1) do
  begin
    EStream[i].PID         := NULL_PID;
    EStream[i].MaxSize     := 0;
    EStream[i].Position    := 0;
    EStream[i].LastCounter := -1;
    setLength(EStream[i].Data,0);
  end;

  // --------------------------------
  //   INIǂݍ
  // --------------------------------
  ProgramCh       := TStringList.Create;
  StationID       := TStringList.Create;
  INI             := TINIFile.Create(IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)))+'OneSeg_Config.ini');
  ForceVideoFirst := False;
  try
    BasePath        := ExcludeTrailingPathDelimiter(INI.ReadString('Config','TSFolder',''));
    OutFolder       := ExcludeTrailingPathDelimiter(INI.ReadString('Extract','OutFolder',''));
    Temporary       := INI.ReadString ('Extract','TemporaryFolder'   ,'');
    DebugMode       := INI.ReadBool   ('Extract','DebugMode'         ,False);
    ForceVideoFirst := INI.ReadBool   ('Extract','ForceVideoFirst'   ,False);
    TVTLtopic       := INI.ReadBool   ('Extract','TVTLtopic'         ,True );
    WatchDogTimeOut := INI.ReadInteger('Extract','WatchDogTimeOut'   ,20   )*1000;
  finally
    INI.Free;
  end;

  INI             := TINIFile.Create(IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)))+'OneSeg_Channels.ini');
  try
    INI.ReadSectionValues('ProgramChannel',ProgramCh);
    INI.ReadSectionValues('stationID',StationID);
  finally
    INI.Free;
  end;

  if (BasePath='') then
  begin
    writeln('INI File error');
    halt(1);
  end;
  TempFile    := IncludeTrailingPathDelimiter(TemporaryPath(Temporary))+GetTempName;

  // --------------------------------
  //   p[^
  // --------------------------------
  ExeName     := ChangeFileExt(ExtractFileName(ParamStr(0)),'');
  Mp4BoxExe   := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)))+MP4BOX;
  Channel     := 0;
  OutFName    := '';
  VideoFName  := TempFile+'.264';
  AudioFName  := TempFile+'.aac';
  FromDate    := 0;
  FromTime    := 0;
  ToDate      := 0;
  ToTime      := 0;
  tsmode      := False;
  ErrorFlg    := False;

  if (ParamCount = 5) then
  begin
    //   p[^ڎw胂[h
    // -------------------------------
    Channel        := StrToIntDef(ParamStr(4),0);
    OutFName       := ParamStr(5);
    tsmode         := (UpperCase(ExtractFileExt(OutFName))='.TS');
    try
      FromDate := StrToDate(ParamStr(1));
      FromTime := StrToTime(ParamStr(2));
      ToDate   := FromDate;
      ToTime   := StrToTime(ParamStr(3));
      if (ToTime<FromTime) then
      begin
        ToDate := IncDay(FromDate,1);
      end;
    except
      writeln('Error: Bad Date/Time');
      ErrorFlg := True;
    end;
  end
    else
  begin
    if (ParamCount = 1) then
    begin
      //   t@Cw胂[h
      // -------------------------------
      CoInitialize(nil);
      FName := ParamStr(1);
      XMLDone := False;
      if FileExists(FName) then
      begin
        if (AnalyzeTBF(FName,ProgramCh,FromDate,FromTime,ToDate,ToTime,Channel,Subject)) then
        begin
          XMLDone := True;
        end
          else
        begin
          if (AnalyzeTVTL(FName,StationID,TVTLTopic,FromDate,FromTime,ToDate,ToTime,Channel,Subject)) then
          begin
            XMLDone := True;
          end
            else
          begin
            if (AnalyzeiEPG(FName,StationID,FromDate,FromTime,ToDate,ToTime,Channel,Subject)) then
            begin
              XMLDone := True;
            end;
          end;
        end;
      end;
      CoUninitialize();

      if (XMLDone) then
      begin
        DateTimeToString(OutFName,'[yymmdd-hhnn]',(FromDate+FromTime));
        OutFName   := IncludeTrailingPathDelimiter(OutFolder)+OutFName;
        OutFName   := OutFName + Subject + '.mp4';
        tsmode     := False;
      end
        else
      begin
        writeln('Error: Bad tag file');
        ErrorFlg := True;
      end;
    end
      else
    begin
      //   G[
      // -------------------------------
      writeln('Usage: '+ExeName+' [From Date] [From Time] [To Time] [Ch] [OutFile]');
      writeln('       '+ExeName+' [tbf/tvtl/iEPG file]');
      ErrorFlg := True;
    end;
  end;
  if (ErrorFlg) then halt(1);
  if (DebugMode) then
  begin
    VideoFName  := ChangeFileExt(OutFName,'.264');
    AudioFName  := ChangeFileExt(OutFName,'.aac');
  end;
  //
  if (not DirectoryExists(BasePath)) then
  begin
    writeln('Error: TS Directory not found');
    halt(1);
  end;
  if ((Channel<13) or (Channel>62))  then
  begin
    writeln('Error: Bad channel number');
    halt(1);
  end;

  OutFile        := nil;
  VideoFile      := nil;
  AudioFile      := nil;
  VideoPID       := 0;
  AudioPID       := 0;
  VideoPTS       := -2;
  AudioPTS       := -2;
  LastVideoPTS   := -2;
  LastAudioPTS   := -2;


  // --------------------------------
  //   Jnn_
  // --------------------------------
  // 1ԑO猟
  LastTime := IncHour(FromDate+FromTime,-1);
  LastPos  := 0;
  hourcnt  := 2;
  if (not HourFileExists(BasePath,Channel,LastTime)) then
  begin
    // OԂ̃t@CȂ瓖00b
    LastTime := FromDate+FromTime;
    LastTime := RecodeMinute(LastTime,0);
    LastTime := RecodeSecond(LastTime,0);
    LastTime := RecodeMilliSecond(LastTime,0);
    LastPos  := 0;
    hourcnt  := 1;
  end;

  // Jnn_̘^t@CI
  if (not HourFileExists(BasePath,Channel,LastTime)) then
  begin
    writeln('Error: No record');
    halt(1);
  end;

  // CfbNX
  NextTime := LastTime;
  while(hourcnt>0) do
  begin
    try
      InFile := TFileStream.Create(DateTimeToFullPath(BasePath,Channel,NextTime)+'.idx', fmOpenRead or fmShareDenyNone);
      try
        InFile.Seek(0,soFromBeginning);

        while(InFile.Position<InFile.Size) do
        begin
          InFile.Read(totcode,5);
          InFile.Read(Posi,sizeof(Posi));
          IdxTime := TOTtoDateTime(totcode);
          if (IdxTime<(FromDate+FromTime)) then
          begin
            LastTime := IdxTime;
            LastPos  := Posi;
          end
            else
          begin
            hourcnt := 0;
            break;
          end;
        end;
        if (hourcnt>0) then
        begin
          NextTime := IncHour(LastTime,1);
          NextTime := RecodeMinute(NextTime,0);
          NextTime := RecodeSecond(NextTime,0);
          NextTime := RecodeMilliSecond(NextTime,0);
          hourcnt := hourcnt - 1;
        end;
      finally
        InFile.Free;
      end;
    except
      writeln('Error: No record');
      halt(1);
    end;
  end;

  writeln('Transport stream found');
  DateTimeToString(str,'yy/mm/dd hh:nn:ss',LastTime);
  writeln('From:'+str+' Pos:'+IntToStr(LastPos));
  LogTime := IncMinute(LastTime,5);
  writeln('-----------------------------------');
  flush(Output);

  // TSt@CV[N
  if (tsmode) then
  begin
    OutFile := TFileStream.Create(OutFName,fmCreate);
  end
    else
  begin
    VideoFile := TFileStream.Create(VideoFName,fmCreate);
    AudioFile := TFileStream.Create(AudioFName,fmCreate);
  end;
  try
    InFile := TFileStream.Create(DateTimeToFullPath(BasePath,Channel,LastTime)+'.ts', fmOpenRead or fmShareDenyNone);
    try
      InFile.Seek(LastPos,soFromBeginning);

      // TSpPbgǂݏo
      while(LastTime<(ToDate+ToTime)) do
      begin
        while(InFile.Position<InFile.Size) do
        begin
          InFile.Read(buf[0],188);
          if (buf[0] = #$47) then
          begin
            // TOTpPbg?
            pid      := ((ord(buf[1]) and $1F) shl 8) or ord(buf[2]);
            case pid of
            $0014:
              begin
                // TOTpPbg
                tot := AnalyzeTOT(buf,totcode);
                if (tot <> 0) then
                begin
                  LastTime := tot;
                  // Oo
                  if (CompareDateTime(LogTime,LastTime)<=0) then
                  begin
                    DateTimeToString(str,'yy/mm/dd hh:nn:ss',LastTime);
                    writeln('Processing:'+str);
                    flush(Output);
                    LogTime := IncMinute(LogTime,5);
                  end;
                end;
              end;
            end;
          end;
          if (tsmode) then
          begin
            OutFile.Write(buf[0],188);
          end
            else
          begin
            AnalyzeTS(buf);
          end;
          if (LastTime>=(ToDate+ToTime)) then break;
        end;

        // ̃t@CH
        if (LastTime<(ToDate+ToTime)) then
        begin
          // ̎
          LastTime := IncHour(LastTime,1);
          LastTime := RecodeMinute(LastTime,0);
          LastTime := RecodeSecond(LastTime,0);
          LastTime := RecodeMilliSecond(LastTime,0);
          LastPos  := 0;
          if (HourFileExists(BasePath,Channel,LastTime)) then
          begin
            InFile.Free;
            InFile := TFileStream.Create(DateTimeToFullPath(BasePath,Channel,LastTime)+'.ts', fmOpenRead or fmShareDenyNone);
            InFile.Seek(LastPos,soFromBeginning);
          end
            else
          begin
            // ̃t@ĈŏI
            LastTime := (ToDate+ToTime);
          end;
        end;
      end;
    finally
      InFile.Free;
    end;

    // Ō̌n(cobt@̃tbV)
    for i:=0 to (MAXPID-1) do
    begin
      if (EStream[i].PID <> NULL_PID) then
      begin
        if (EStream[i].Position<>0) then
        begin
          // PESo
          WritePES(EStream[i]);

          // PES
          setLength(EStream[i].Data,0);
          EStream[i].PID         := NULL_PID;
          EStream[i].MaxSize     := 0;
          EStream[i].Position    := 0;
          EStream[i].LastCounter := -1;
        end;
      end;
    end;
  except
    //
  end;
  if (tsmode) then
  begin
    OutFile.Free;
  end
    else
  begin
    VideoFile.Free;
    AudioFile.Free;
  end;

  writeln('Finished');
  flush(Output);

  // MP4BoxN
  if (not tsmode) then
  begin
    writeln('VideoPTS:'+IntToStr(VideoPTS));
    writeln('AudioPTS:'+IntToStr(AudioPTS));
    flush(Output);
    if ((VideoPTS>0) and (AudioPTS>0)) then
    begin
      if (VideoPTS>AudioPTS) then
      begin
        // delay Video
        delay := (VideoPTS-AudioPTS) div 90;
        param := '-fps 14.985 -add "'+VideoFName+'":delay='+IntToStr(delay)+' -add "'+AudioFName+'" -new "'+OutFName+'"';
      end
        else
      begin
        // delay Audio
        delay := (AudioPTS-VideoPTS) div 90;
        param := '-fps 14.985 -add "'+VideoFName+'" -add "'+AudioFName+'":delay='+IntToStr(delay)+' -new "'+OutFName+'"';
      end;
    end
      else
    begin
      // no delay
      param := '-fps 14.985 -add "'+VideoFName+'" -add "'+AudioFName+'" -new "'+OutFName+'"';
    end;
    ExecuteEXE(Mp4BoxExe,param);
    if (not DebugMode) then
    begin
      DeleteFile(PChar(VideoFName));
      DeleteFile(PChar(AudioFName));
    end;
  end;

  ProgramCh.Free;
  StationID.Free;

  if (DebugMode) then
  begin
    readln(str);
  end;
end.

